Imports GMDLLTester_VB.GlobalMapperInterface
Imports System.Runtime.InteropServices

Public Class Form1
    Inherits System.Windows.Forms.Form

    'Dynamic array for holding list of loaded layer handles
    Public sLayerHandleList(10) As Int32
    Public sLayerCount As Int32

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents OpenFileDialog1 As System.Windows.Forms.OpenFileDialog
    Friend WithEvents LoadFileButton As System.Windows.Forms.Button
    Friend WithEvents MapViewPanel As System.Windows.Forms.PictureBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.OpenFileDialog1 = New System.Windows.Forms.OpenFileDialog
        Me.LoadFileButton = New System.Windows.Forms.Button
        Me.MapViewPanel = New System.Windows.Forms.PictureBox
        Me.SuspendLayout()
        '
        'LoadFileButton
        '
        Me.LoadFileButton.Location = New System.Drawing.Point(16, 256)
        Me.LoadFileButton.Name = "LoadFileButton"
        Me.LoadFileButton.Size = New System.Drawing.Size(104, 23)
        Me.LoadFileButton.TabIndex = 1
        Me.LoadFileButton.Text = "Load File..."
        '
        'MapViewPanel
        '
        Me.MapViewPanel.Location = New System.Drawing.Point(16, 8)
        Me.MapViewPanel.Name = "MapViewPanel"
        Me.MapViewPanel.Size = New System.Drawing.Size(344, 240)
        Me.MapViewPanel.TabIndex = 2
        Me.MapViewPanel.TabStop = False
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(368, 342)
        Me.Controls.Add(Me.MapViewPanel)
        Me.Controls.Add(Me.LoadFileButton)
        Me.Name = "Form1"
        Me.Text = "Form1"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub LoadFileButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LoadFileButton.Click

        'Show the open file dialog
        OpenFileDialog1.ShowDialog()

        ' Load the file
        Dim theErr As Int32
        Dim theLayerList As IntPtr
        Dim theLayerCount As Int32
        theLayerList = IntPtr.Zero
        theLayerCount = 0
        theErr = GM_LoadLayerList(OpenFileDialog1.FileName, theLayerList, theLayerCount, 0)

        ' Get information about the layers we loaded
        If (0 = theErr) Then
            Dim i As Int32
            For i = 0 To theLayerCount - 1
                ' Get the layer handle for this layer
                Dim theLayerHandle As Int32
                theLayerHandle = Marshal.ReadInt32(theLayerList, i * 4)

                ' Get the pointer to the layer info structure
                Dim theLayerInfoPtr As IntPtr
                theLayerInfoPtr = GM_GetLayerInfo(theLayerHandle)

                ' Convert the pointer to our structure
                Dim theLayerInfo As GM_LayerInfo_t
                theLayerInfo = CType(Marshal.PtrToStructure(theLayerInfoPtr, GetType(GM_LayerInfo_t)), GM_LayerInfo_t)

                'Add the layer handle to our handle array. We will have to grow
                'it if it is full.
                If (sLayerCount = (sLayerHandleList.GetUpperBound(0) + 1)) Then
                    ReDim Preserve sLayerHandleList(sLayerCount + 1)
                End If
                sLayerHandleList(sLayerCount) = theLayerHandle
                sLayerCount = sLayerCount + 1

                ' Now do some API tests
                TestAPI(theLayerHandle, theLayerInfo)
            Next

            'Redraw
            MapViewPanel.Invalidate()
        End If
    End Sub

    Private Sub MapViewPanel_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MapViewPanel.Paint

        'Draw the loaded maps to the given panel
        Dim theErr As Int32
        Dim theDC As IntPtr
        theDC = e.Graphics().GetHdc()
        theErr = GlobalMapperInterface.GM_DrawLayerList _
            ( _
            theDC, _
            sLayerHandleList(0), _
            sLayerCount, _
            GM_DrawFlags_t32.GM_DrawFlags_EraseBackground, _
            IntPtr.Zero, _
            0, _
            0, _
            MapViewPanel.Width, _
            MapViewPanel.Height _
            )
        e.Graphics().ReleaseHdc(theDC)

    End Sub

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'Initialize the layer count
        sLayerCount = 0

        'Set the map panel background color to white
        GlobalMapperInterface.GM_SetBackgroundColor(RGB(255, 255, 255))
    End Sub

    Private Sub Form1_Closed(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        'Close all of the layers that we loaded
        Dim i As Int32
        For i = 0 To sLayerCount - 1
            'Close the layer
            GM_CloseLayer(sLayerHandleList(i))
        Next
        sLayerCount = 0
    End Sub

    Private Sub TestAPI _
    ( _
        ByVal aLayerHandle As Int32, _
        ByRef aLayerInfo As GM_LayerInfo_t _
    )
        Dim theErr As Int32

        ' If this is a raster layer, get its raster display options and then make it partially transparent
        If (aLayerInfo.mHasRasterData) Then
            ' Get the current raster display options
            Dim theDispOpts As GM_RasterDisplayOptions_t
            theDispOpts.mSize = Len(theDispOpts)
            theErr = GM_GetRasterDisplayOptions(aLayerHandle, theDispOpts)
            If (0 = theErr) Then
                ' Make the layer display translucent
                theDispOpts.mTranslucency = 400

                'Make white transparent
                theDispOpts.mTransparent = 1
                theDispOpts.mTransparentColor = &HFFFFFF

                ' Set the new options
                GM_SetRasterDisplayOptions(aLayerHandle, theDispOpts)
            End If

        End If

        ' If this layer has area features, test getting one
        If (aLayerInfo.mNumAreas > 0) Then
            'Get the first area
            Dim theAreaFeaturePtr As IntPtr
            theAreaFeaturePtr = GM_GetAreaFeature(aLayerHandle, 0)

            'Extract into our own structure, then free
            If (theAreaFeaturePtr <> IntPtr.Zero) Then
                'Extract into our own structure
                Dim theAreaFeature As GM_AreaFeature_t
                theAreaFeature = CType(Marshal.PtrToStructure(theAreaFeaturePtr, GetType(GM_AreaFeature_t)), GM_AreaFeature_t)

                'Extract each vertex just to demonstrate how to extract things from a pointer
                Dim thePoint As GM_Point_t
                Dim thePointPtr As IntPtr
                Dim j As UInt32
                For j = 0 To theAreaFeature.mNumPoints - 1
                    thePointPtr = theAreaFeature.mPointList.ToInt32() + j * Len(thePoint)
                    thePoint = CType(Marshal.PtrToStructure(thePointPtr, GetType(GM_Point_t)), GM_Point_t)
                Next j

                'Free the area
                GM_FreeAreaFeature(theAreaFeaturePtr)
            End If
        End If


    End Sub


End Class
